diff --git a/libglusterfs/src/common-utils.c b/libglusterfs/src/common-utils.c
index b325dfbaba0..e4f1c209310 100644
--- a/libglusterfs/src/common-utils.c
+++ b/libglusterfs/src/common-utils.c
@@ -4321,3 +4321,34 @@ gf_unlink(const char *path)
     }
     return _gf_true;
 }
+
+int
+gf_rebalance_thread_count(char *str, char **errmsg)
+{
+    int count = 0, lim = sysconf(_SC_NPROCESSORS_ONLN);
+
+    /* An option should be one of lazy|normal|aggressive or
+       a number from 1 to the number of cores in the machine. */
+
+    if (!strcasecmp(str, "lazy"))
+        return 1;
+    else if (!strcasecmp(str, "normal"))
+        return 2;
+    else if (!strcasecmp(str, "aggressive"))
+        return max(lim - 4, 4);
+    else if (gf_string2int(str, &count) == 0) {
+        if (count > 0 && count <= lim)
+            return count;
+        else {
+            if (gf_asprintf(errmsg, "number of rebalance threads should be "
+                            "in range from 1 to %d, not %d", lim, count) < 0)
+                *errmsg = NULL;
+            return -1;
+        }
+    }
+    if (gf_asprintf(errmsg, "number of rebalance threads should "
+                    "be {lazy|normal|aggressive} or a number in "
+                    "range from 1 to %d, not %s", lim, str) < 0)
+        *errmsg = NULL;
+    return -1;
+}
diff --git a/libglusterfs/src/glusterfs/common-utils.h b/libglusterfs/src/glusterfs/common-utils.h
index 567e27b19d7..3c397b873ae 100644
--- a/libglusterfs/src/glusterfs/common-utils.h
+++ b/libglusterfs/src/glusterfs/common-utils.h
@@ -1122,6 +1122,9 @@ recursive_rmdir(const char *delete_path);
 gf_boolean_t
 gf_unlink(const char *path);
 
+int
+gf_rebalance_thread_count(char *str, char **errmsg);
+
 int
 gf_get_index_by_elem(char **array, char *elem);
 
diff --git a/libglusterfs/src/libglusterfs.sym b/libglusterfs/src/libglusterfs.sym
index 4dc7f2eccc2..aace13bd94b 100644
--- a/libglusterfs/src/libglusterfs.sym
+++ b/libglusterfs/src/libglusterfs.sym
@@ -654,6 +654,7 @@ __gf_realloc
 _gf_ref_get
 _gf_ref_init
 _gf_ref_put
+gf_rebalance_thread_count
 gf_rev_dns_lookup
 gf_rsync_strong_checksum
 gf_rsync_md5_checksum
diff --git a/xlators/cluster/dht/src/dht-common.h b/xlators/cluster/dht/src/dht-common.h
index e2ef496e268..201c6d04237 100644
--- a/xlators/cluster/dht/src/dht-common.h
+++ b/xlators/cluster/dht/src/dht-common.h
@@ -34,7 +34,6 @@
 /* Namespace synchronization */
 #define DHT_ENTRY_SYNC_DOMAIN "dht.entry.sync"
 #define DHT_LAYOUT_HASH_INVALID 1
-#define MAX_REBAL_THREADS sysconf(_SC_NPROCESSORS_ONLN)
 
 #define DHT_DIR_STAT_BLOCKS 8
 #define DHT_DIR_STAT_SIZE 4096
@@ -539,8 +538,6 @@ struct dht_conf {
     subvol_nodeuuids_info_t *local_nodeuuids;
     int32_t local_subvols_cnt;
 
-    int dthrottle;
-
     /* Hard link handle requirement for migration triggered from client*/
     synclock_t link_lock;
 
diff --git a/xlators/cluster/dht/src/dht-rebalance.c b/xlators/cluster/dht/src/dht-rebalance.c
index edc68d8113c..8d33e427846 100644
--- a/xlators/cluster/dht/src/dht-rebalance.c
+++ b/xlators/cluster/dht/src/dht-rebalance.c
@@ -25,9 +25,6 @@
 #define ESTIMATE_START_INTERVAL 600 /* 10 mins */
 #define HARDLINK_MIG_INPROGRESS -2
 #define SKIP_MIGRATION_FD_POSITIVE -3
-#ifndef MAX
-#define MAX(a, b) (((a) > (b)) ? (a) : (b))
-#endif
 
 #define GF_CRAWL_INDEX_MOVE(idx, sv_cnt)                                       \
     {                                                                          \
@@ -4061,7 +4058,7 @@ gf_defrag_parallel_migration_init(xlator_t *this, gf_defrag_info_t *defrag,
 
     INIT_LIST_HEAD(&(defrag->queue[0].list));
 
-    thread_spawn_count = MAX(MAX_REBAL_THREADS, 4);
+    thread_spawn_count = max(sysconf(_SC_NPROCESSORS_ONLN), 4);
 
     gf_msg_debug(this->name, 0, "thread_spawn_count: %d", thread_spawn_count);
 
diff --git a/xlators/cluster/dht/src/dht-shared.c b/xlators/cluster/dht/src/dht-shared.c
index 6b274634c6a..8f2c4b5d465 100644
--- a/xlators/cluster/dht/src/dht-shared.c
+++ b/xlators/cluster/dht/src/dht-shared.c
@@ -13,10 +13,6 @@
 #include "dht-common.h"
 #include "dht-messages.h"
 
-#ifndef MAX
-#define MAX(a, b) (((a) > (b)) ? (a) : (b))
-#endif
-
 /* TODO:
    - use volumename in xattr instead of "dht"
    - use NS locks
@@ -364,49 +360,23 @@ dht_set_subvol_range(xlator_t *this)
 static int
 dht_configure_throttle(xlator_t *this, dht_conf_t *conf, char *temp_str)
 {
-    int rebal_thread_count = 0;
-    int ret = 0;
-
-    pthread_mutex_lock(&conf->defrag->dfq_mutex);
-    {
-        if (!strcasecmp(temp_str, "lazy")) {
-            conf->defrag->recon_thread_count = 1;
-        } else if (!strcasecmp(temp_str, "normal")) {
-            conf->defrag->recon_thread_count = 2;
-        } else if (!strcasecmp(temp_str, "aggressive")) {
-            conf->defrag->recon_thread_count = MAX(MAX_REBAL_THREADS - 4, 4);
-        } else if ((gf_string2int(temp_str, &rebal_thread_count) == 0)) {
-            if ((rebal_thread_count > 0) &&
-                (rebal_thread_count <= MAX_REBAL_THREADS)) {
-                conf->defrag->recon_thread_count = rebal_thread_count;
-                pthread_mutex_unlock(&conf->defrag->dfq_mutex);
-                gf_msg(this->name, GF_LOG_INFO, 0, 0,
-                       "rebal thread count configured to %d",
-                       rebal_thread_count);
-                goto out;
-            } else {
-                pthread_mutex_unlock(&conf->defrag->dfq_mutex);
-                gf_msg(this->name, GF_LOG_ERROR, 0, DHT_MSG_INVALID_OPTION,
-                       "Invalid option: Reconfigure: "
-                       "rebal-throttle should be "
-                       "within range of 0 and maximum number of"
-                       " cores available");
-                ret = -1;
-                goto out;
-            }
-        } else {
-            gf_msg(this->name, GF_LOG_ERROR, 0, DHT_MSG_INVALID_OPTION,
-                   "Invalid option: Reconfigure: "
-                   "rebal-throttle should be {lazy|normal|aggressive}"
-                   " or a number up to the number of cores available,"
-                   " not (%s), defaulting to (%d)",
-                   temp_str, conf->dthrottle);
-            ret = -1;
-        }
+    char *errmsg = NULL;
+    int ret, count = gf_rebalance_thread_count(temp_str, &errmsg);
+
+    if (count > 0) {
+        pthread_mutex_lock(&conf->defrag->dfq_mutex);
+        conf->defrag->recon_thread_count = count;
+        pthread_mutex_unlock(&conf->defrag->dfq_mutex);
+        gf_msg(this->name, GF_LOG_INFO, 0, 0, "rebalance "
+               "thread count configured to %d", count);
+        ret = 0;
+    } else {
+        gf_msg(this->name, GF_LOG_ERROR, 0, DHT_MSG_INVALID_OPTION, "%s",
+               errmsg ? errmsg : "<out of memory>");
+        if (errmsg)
+            GF_FREE(errmsg);
+        ret = -1;
     }
-    pthread_mutex_unlock(&conf->defrag->dfq_mutex);
-
-out:
     return ret;
 }
 
diff --git a/xlators/mgmt/glusterd/src/glusterd-volume-set.c b/xlators/mgmt/glusterd/src/glusterd-volume-set.c
index 3c46cbda3c0..fdf7d42fa29 100644
--- a/xlators/mgmt/glusterd/src/glusterd-volume-set.c
+++ b/xlators/mgmt/glusterd/src/glusterd-volume-set.c
@@ -71,50 +71,13 @@ static int
 validate_defrag_throttle_option(glusterd_volinfo_t *volinfo, dict_t *dict,
                                 char *key, char *value, char **op_errstr)
 {
-    char errstr[2048] = "";
     int ret = 0;
-    xlator_t *this = THIS;
-    int thread_count = 0;
-    long int cores_available = 0;
-
-    cores_available = sysconf(_SC_NPROCESSORS_ONLN);
-
-    /* Throttle option should be one of lazy|normal|aggressive or a number
-     * configured by user max up to the number of cores in the machine */
-
-    if (!strcasecmp(value, "lazy") || !strcasecmp(value, "normal") ||
-        !strcasecmp(value, "aggressive")) {
-        ret = 0;
-    } else if ((gf_string2int(value, &thread_count) == 0)) {
-        if ((thread_count > 0) && (thread_count <= cores_available)) {
-            ret = 0;
-        } else {
-            ret = -1;
-            snprintf(errstr, sizeof(errstr),
-                     "%s should be within"
-                     " range of 0 and maximum number of cores "
-                     "available (cores available - %ld)",
-                     key, cores_available);
-
-            gf_msg(this->name, GF_LOG_ERROR, EINVAL, GD_MSG_INVALID_ENTRY, "%s",
-                   errstr);
-
-            *op_errstr = gf_strdup(errstr);
-        }
-    } else {
+
+    if (gf_rebalance_thread_count(value, op_errstr) < 1) {
+        gf_msg(THIS->name, GF_LOG_ERROR, EINVAL, GD_MSG_INVALID_ENTRY, "%s",
+               *op_errstr ? *op_errstr : "<out of memory>");
         ret = -1;
-        snprintf(errstr, sizeof(errstr),
-                 "%s should be "
-                 "{lazy|normal|aggressive} or a number up to number of"
-                 " cores available (cores available - %ld)",
-                 key, cores_available);
-        gf_msg(this->name, GF_LOG_ERROR, EINVAL, GD_MSG_INVALID_ENTRY, "%s",
-               errstr);
-        *op_errstr = gf_strdup(errstr);
     }
-
-    gf_msg_debug(this->name, 0, "Returning %d", ret);
-
     return ret;
 }
 
